# Magisk mount
SKIPMOUNT=false

# load system.prop
PROPFILE=true

# Installation Preview 1
print_modname() {
MODNAME=`grep_prop name $TMPDIR/module.prop`
MODVER=`grep_prop version $TMPDIR/module.prop`
DV=`grep_prop author $TMPDIR/module.prop`
Device=`getprop ro.product.device`
Model=`getprop ro.product.model`
Brand=`getprop ro.product.brand` 
Architecture=`getprop ro.product.cpu.abi`
SDK=`getprop ro.system.build.version.sdk`
Android=`getprop ro.system.build.version.release`
Type=`getprop ro.system.build.type`
Built=`getprop ro.system.build.date`
Time=$(date "+%d, %b - %H:%M %Z")

sleep 0.1
echo "-------------------------------------"
echo "Fetching module info..."
echo "-------------------------------------"
sleep 1.5
echo -e "- Author：\c"
echo "$DV"
sleep 0.5
echo -e "- Module：\c"
echo "$MODNAME"
sleep 0.5
echo -e "- Version：\c"
echo "$MODVER"
sleep 0.5
echo -e "- Provider：\c"
if [ "$BOOTMODE" ] && [ "$KSU" ]; then
ui_print "KernelSU app"
 sed -i "s/^des.*/description= [🦄 KernelSU is loaded] Enable ${MODNAME} /g" $MODPATH/module.prop
ui_print "- KernelSU：$KSU_KERNEL_VER_CODE (kernel) + $KSU_VER_CODE (ksud)"
 if [ "$(which magisk)" ]; then
echo "-------------------------------------"
ui_print "! Multiple root implementation is NOT supported!"
abort "-------------------------------------"
 fi
elif [ "$BOOTMODE" ] && [ "$MAGISK_VER_CODE" ]; then
ui_print "Magisk app"
 sed -i "s/^des.*/description= [🪷 Magisk is loaded] Enable ${MODNAME} /g" $MODPATH/module.prop
# Display warning message for Magisk users
ui_print "==================================================="
ui_print "☝️🤓 MAGISK DETECTED"
ui_print " "
 sleep 1
ui_print "⚠️ The Magisk app may crash during 1st time installation."
ui_print " To fix it, reflash this module again without rebooting."
ui_print " "
ui_print "Installation will begin in 5 seconds."
#ui_print "==================================================="
 sleep 5
else
echo "-------------------------------------"
ui_print "Installation from recovery is not supported"
ui_print "Please install from KernelSU or Magisk app"
abort "-------------------------------------"
fi
echo "-------------------------------------"
echo "Fetching device info..."
echo "-------------------------------------"
sleep 1.5
echo "- Brand：$Brand"
sleep 0.5
echo "- Device：$Device"
sleep 0.5
echo "- Model：$Model"
sleep 0.5
echo "- RAM：$(free | grep Mem | awk '{print $2}')"
sleep 0.5
echo "-------------------------------------"
echo "Fetching ROM info..."
echo "-------------------------------------"
sleep 1.5
echo "- Android：$Android"
sleep 0.5
echo -e "- Kernel：\c"
echo "$(uname -r)"
sleep 0.5
echo "- CPU：$Architecture"
sleep 0.5
echo "- SDK：$SDK"
sleep 0.5
echo "- Build Date：$Built"
sleep 0.5
echo "- Build Type：$Type"
sleep 1
echo "-------------------------------------"
echo "✦ Running $MODNAME"
ui_print "✦ Flashing started at $Time " 
echo "-------------------------------------"
sleep 1.5    
echo "-------------------------------------"
echo "✦ Disabled UNNECESSARY GMS SERVICES"
#ui_print " "
# This code aims to disable the advertising and tracking capabilities of Google Play services.
su -c "pm disable com.google.android.gms/com.google.android.gms.ads.identifier.service.AdvertisingIdNotificationService"
su -c "pm disable com.google.android.gms/com.google.android.gms.ads.identifier.service.AdvertisingIdService"
#su -c "pm disable com.google.android.gms/com.google.android.gms.nearby.mediums.nearfieldcommunication.NfcAdvertisingService"
#ui_print "✦ Disabled advertising and tracking in Google Play services."
#ui_print " "
sleep 1.5

# This code aims to restrict Google's data collection and analytics on your Android device.
su -c "pm disable com.google.android.gms/com.google.android.gms.analytics.AnalyticsService"
su -c "pm disable com.google.android.gms/com.google.android.gms.analytics.AnalyticsTaskService"
su -c "pm disable com.google.android.gms/com.google.android.gms.analytics.internal.PlayLogReportingService"
su -c "pm disable com.google.android.gms/com.google.android.gms.stats.eastworld.EastworldService"
su -c "pm disable com.google.android.gms/com.google.android.gms.stats.service.DropBoxEntryAddedService"
su -c "pm disable com.google.android.gms/com.google.android.gms.stats.PlatformStatsCollectorService"
su -c "pm disable com.google.android.gms/com.google.android.gms.common.stats.GmsCoreStatsService"
su -c "pm disable com.google.android.gms/com.google.android.gms.common.stats.StatsUploadService"
su -c "pm disable com.google.android.gms/com.google.android.gms.backup.stats.BackupStatsService"
su -c "pm disable com.google.android.gms/com.google.android.gms.checkin.CheckinApiService"
su -c "pm disable com.google.android.gms/com.google.android.gms.checkin.CheckinService"
su -c "pm disable com.google.android.gms/com.google.android.gms.tron.CollectionService"
su -c "pm disable com.google.android.gms/com.google.android.gms.common.config.PhenotypeCheckinService"
ui_print "Restricted Google’s data collection on your device."
#ui_print " "
#sleep 1.5

# This code aims to disable HardwareArProviderService that eats your battery 24×7
su -c "pm disable com.google.android.gms/com.google.android.location.internal.server.HardwareArProviderService"
#ui_print "✦ Disabled the battery-draining HardwareArProviderService."
#ui_print " "
#sleep 1.5

# This code aims to disable bug reporting functionality of gms.
su -c "pm disable com.google.android.gms/com.google.android.gms.feedback.FeedbackAsyncService"
su -c "pm disable com.google.android.gms/com.google.android.gms.feedback.LegacyBugReportService"
su -c "pm disable com.google.android.gms/com.google.android.gms.feedback.OfflineReportSendTaskService"
su -c "pm disable com.google.android.gms/com.google.android.gms.googlehelp.metrics.ReportBatchedMetricsGcmTaskService"
su -c "pm disable com.google.android.gms/com.google.android.gms.analytics.internal.PlayLogReportingService"
su -c "pm disable com.google.android.gms/com.google.android.gms.locationsharingreporter.service.reporting.periodic.PeriodicReporterMonitoringService"
su -c "pm disable com.google.android.gms/com.google.android.location.reporting.service.ReportingAndroidService"
su -c "pm disable com.google.android.gms/com.google.android.location.reporting.service.ReportingSyncService"
su -c "pm disable com.google.android.gms/com.google.android.gms.common.stats.net.NetworkReportService"
su -c "pm disable com.google.android.gms/com.google.android.gms.presencemanager.service.PresenceManagerPresenceReportService"
su -c "pm disable com.google.android.gms/com.google.android.gms.usagereporting.service.UsageReportingIntentService"
#ui_print "✦ Disabled bug reporting in Google Play services."
#ui_print " "
#sleep 1.5

# This code aims to disable Google Cast services.
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.media.CastMediaRoute2ProviderService"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.media.CastMediaRoute2ProviderService_Isolated"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.media.CastMediaRoute2ProviderService_Persistent"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.media.CastMediaRouteProviderService"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.media.CastMediaRouteProviderService_Isolated"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.media.CastMediaRouteProviderService_Persistent"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.media.CastRemoteDisplayProviderService"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.media.CastRemoteDisplayProviderService_Isolated"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.media.CastRemoteDisplayProviderService_Persistent"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.service.CastPersistentService_Persistent"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.service.CastSocketMultiplexerLifeCycleService"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.service.CastSocketMultiplexerLifeCycleService_Isolated"
su -c "pm disable com.google.android.gms/com.google.android.gms.cast.service.CastSocketMultiplexerLifeCycleService_Persistent"
su -c "pm disable com.google.android.gms/com.google.android.gms.chimera.CastPersistentBoundBrokerService"
#ui_print "✦ Disabled Google Cast services."
#ui_print " "
#sleep 1.5

# This code aims to disable debugging services related to Google Play Services.
#su -c "pm disable com.google.android.gms/com.google.android.gms.nearby.messages.debug.DebugPokeService"
su -c "pm disable com.google.android.gms/com.google.android.gms.clearcut.debug.ClearcutDebugDumpService"
#ui_print "✦ Disabled debugging services in Google Play Services."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to component discovery within Google Play Services and Firebase.
su -c "pm disable com.google.firebase.components.ComponentDiscoveryService"
#su -c "pm disable com.google.android.gms/com.google.android.gms.nearby.discovery.service.DiscoveryService"
#su -c "pm disable com.google.android.gms/com.google.mlkit.common.internal.MlKitComponentDiscoveryService"
#ui_print "✦ Disabled component discovery services in Google Play and Firebase."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to location and time zone information.
su -c "pm disable com.google.android.gms/com.google.android.gms.geotimezone.GeoTimeZoneService"
su -c "pm disable com.google.android.gms/com.google.android.gms.location.geocode.GeocodeService"
#ui_print "✦ Disabled location and time zone services."
#ui_print " "
#sleep 1.5

# This code aims to enable specific services related to Google Play Services, particularly those associated with authentication and account management.
su -c "pm enable com.google.android.gms/com.google.android.gms.chimera.GmsIntentOperationService_AuthAccountIsolated com.google.android.gms/com.google.android.gms.chimera.GmsIntentOperationService_AuthAccountIsolate"
su -c "pm enable com.google.android.gms/com.google.android.gms.chimera.PersistentApiService_AuthAccountIsolated"
su -c "pm enable com.google.android.gms/com.google.android.gms.chimera.PersistentIntentOperationService_AuthAccountIsolated"
#ui_print "✦ Disabled key authentication services in Google Play."
#ui_print " "
#sleep 1.5

# This code aims to disable various background update services.
su -c "pm disable com.google.android.gms/com.google.android.gms.auth.folsom.service.FolsomPublicKeyUpdateService"
su -c "pm disable com.google.android.gms/com.google.android.gms.fonts.update.UpdateSchedulerService"
su -c "pm disable com.google.android.gms/com.google.android.gms.icing.proxy.IcingInternalCorporaUpdateService"
su -c "pm disable com.google.android.gms/com.google.android.gms.instantapps.routing.DomainFilterUpdateService"
su -c "pm disable com.google.android.gms/com.google.android.gms.mobiledataplan.service.PeriodicUpdaterService"
su -c "pm disable com.google.android.gms/com.google.android.gms.phenotype.service.sync.PackageUpdateTaskService"
su -c "pm disable com.google.android.gms/com.google.android.gms.update.SystemUpdateGcmTaskService"
su -c "pm disable com.google.android.gms/com.google.android.gms.update.SystemUpdateService"
su -c "pm disable com.google.android.gms/com.google.android.gms.update.UpdateFromSdCardService"
#ui_print "✦ Disabled various background update services."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to smartwatches and wearables.
su -c "pm disable com.google.android.gms/com.google.android.gms.backup.wear.BackupSettingsListenerService"
su -c "pm disable com.google.android.gms/com.google.android.gms.dck.service.DckWearableListenerService"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.wearable.WearableSyncAccountService"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.wearable.WearableSyncConfigService"
#su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.wearable.WearableSyncConnectionService"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.wearable.WearableSyncMessageService"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.wearables.WearableSyncService"
#su -c "pm disable com.google.android.gms/com.google.android.gms.wearable.service.WearableControlService"
su -c "pm disable com.google.android.gms/com.google.android.gms.wearable.service.WearableService"
#su -c "pm disable com.google.android.gms/com.google.android.gms.nearby.fastpair.service.WearableDataListenerService"
su -c "pm disable com.google.android.gms/com.google.android.location.wearable.WearableLocationService"
su -c "pm disable com.google.android.gms/com.google.android.location.fused.wearable.GmsWearableListenerService"
su -c "pm disable com.google.android.gms/com.google.android.gms.mdm.services.MdmPhoneWearableListenerService"
su -c "pm disable com.google.android.gms/com.google.android.gms.tapandpay.wear.WearProxyService"
#ui_print "✦ Disabled services for smartwatches and wearables."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to Trusted Agents / Find My Device
#su -c "pm disable com.google.android.gms/com.google.android.gms.auth.trustagent.GoogleTrustAgent"
#su -c "pm disable com.google.android.gms/com.google.android.gms.trustagent.api.bridge.TrustAgentBridgeService"
#su -c "pm disable com.google.android.gms/com.google.android.gms.trustagent.api.state.TrustAgentState"
#ui_print "✦ Disabled Trusted Agents / Find My Device services." 
#ui_print " "
#sleep 1.5

# This code aims to disable services related to enpromo"
su -c "pm disable com.google.android.gms/com.google.android.gms.enpromo.PromoInternalPersistentService"
su -c "pm disable com.google.android.gms/com.google.android.gms.enpromo.PromoInternalService"
#ui_print "✦ Disabled enpromo-related services."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to emergency features and potentially child safety settings. 
su -c "pm disable com.google.android.gms/com.google.android.gms.thunderbird.EmergencyLocationService" 
su -c "pm disable com.google.android.gms/com.google.android.gms.thunderbird.EmergencyPersistentService"
su -c "pm disable com.google.android.gms/com.google.android.gms.kids.chimera.KidsServiceProxy"
su -c "pm disable com.google.android.gms/com.google.android.gms.personalsafety.service.PersonalSafetyService"
#ui_print "✦ Disabled emergency features and child safety services."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to Google Fit health and fitness tracking app.
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.cache.DataUpdateListenerCacheService"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.ble.FitBleBroker"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.config.FitConfigBroker"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.goals.FitGoalsBroker"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.history.FitHistoryBroker"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.internal.FitInternalBroker"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.proxy.FitProxyBroker"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.recording.FitRecordingBroker"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.sensors.FitSensorsBroker"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.service.sessions.FitSessionsBroker"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.sensors.sample.CollectSensorService"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.sync.FitnessSyncAdapterService" 
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.sync.SyncGcmTaskService"
#ui_print "✦ Disabled Google Fit health tracking services."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to Google Nearby
#su -c "pm disable com.google.android.gms/com.google.android.gms.nearby.bootstrap.service.NearbyBootstrapService"
#su -c "pm disable com.google.android.gms/com.google.android.gms.nearby.connection.service.NearbyConnectionsAndroidService"
#su -c "pm disable com.google.android.gms/com.google.location.nearby.direct.service.NearbyDirectService"
#su -c "pm disable com.google.android.gms/com.google.android.gms.nearby.messages.service.NearbyMessagesService"
##ui_print "✦ Disabled Google Nearby services."
##ui_print " "
##sleep 1.5

# This code aims to disable services related to logging and data collection.
su -c "pm disable com.google.android.gms/com.google.android.gms.analytics.internal.PlayLogReportingService"
su -c "pm disable com.google.android.gms/com.google.android.gms.romanesco.ContactsLoggerUploadService"
su -c "pm disable com.google.android.gms/com.google.android.gms.magictether.logging.DailyMetricsLoggerService"
su -c "pm disable com.google.android.gms/com.google.android.gms.checkin.EventLogService"
su -c "pm disable com.google.android.gms/com.google.android.gms.backup.component.FullBackupJobLoggerService"
#ui_print "✦ Disabled logging and data collection services."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to security, app verification, and potentially network management.
su -c "pm disable com.google.android.gms/com.google.android.gms.security.safebrowsing.SafeBrowsingUpdateTaskService"
su -c "pm disable com.google.android.gms/com.google.android.gms.security.verifier.ApkUploadService"
su -c "pm disable com.google.android.gms/com.google.android.gms.security.verifier.InternalApkUploadService"
su -c "pm disable com.google.android.gms/com.google.android.gms.security.snet.SnetIdleTaskService"
su -c "pm disable com.google.android.gms/com.google.android.gms.security.snet.SnetNormalTaskService"
su -c "pm disable com.google.android.gms/com.google.android.gms.security.snet.SnetService"
su -c "pm disable com.google.android.gms/com.google.android.gms.tapandpay.security.StorageKeyCacheService"
su -c "pm disable com.google.android.gms/com.google.android.gms.droidguard.DroidGuardGcmTaskService"
su -c "pm disable com.google.android.gms/com.google.android.gms.pay.security.storagekey.service.StorageKeyCacheService"
#ui_print "✦ Disabled security and app verification services."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to Google Pay (formerly Android Pay) & Google Wallet.
su -c "pm disable com.google.android.gms/com.google.android.gms.tapandpay.gcmtask.TapAndPayGcmTaskService"
su -c "pm disable com.google.android.gms/com.google.android.gms.tapandpay.globalactions.QuickAccessWalletService"
su -c "pm disable com.google.android.gms/com.google.android.gms.tapandpay.globalactions.WalletQuickAccessWalletService"
su -c "pm disable com.google.android.gms/com.google.android.gms.pay.gcmtask.PayGcmTaskService"
su -c "pm disable com.google.android.gms/com.google.android.gms.pay.hce.service.PayHceService"
su -c "pm disable com.google.android.gms/com.google.android.gms.pay.notifications.PayNotificationService"
su -c "pm disable com.google.android.gms/com.google.android.gms.wallet.service.PaymentService"
su -c "pm disable com.google.android.gms/com.google.android.gms.wallet.service.WalletGcmTaskService"
#ui_print "✦ Disabled Google Pay and Wallet services."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to location.
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.cache.DataUpdateListenerCacheService"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.sensors.sample.CollectSensorService"
su -c "pm disable com.google.android.gms/com.google.android.gms.fitness.sync.SyncGcmTaskService"
su -c "pm disable com.google.android.gms/com.google.android.location.fused.FusedLocationService"
#su -c "pm enable com.google.android.gms/com.google.android.location.internal.server.GoogleLocationService"
su -c "pm disable com.google.android.gms/com.google.android.location.network.NetworkLocationService"
su -c "pm disable com.google.android.gms/com.google.android.location.persistent.LocationPersistentService"
su -c "pm disable com.google.android.gms/com.google.android.location.reporting.service.LocationHistoryInjectorService"
su -c "pm disable com.google.android.gms/com.google.android.location.util.LocationAccuracyInjectorService"
su -c "pm disable com.google.android.gms/com.google.android.location.wearable.WearableLocationService"
su -c "pm disable com.google.android.gms/com.google.android.gms.locationsharing.service.LocationSharingSettingInjectorService"
su -c "pm disable com.google.android.gms/com.google.android.gms.locationsharing.service.LocationSharingService"
su -c "pm disable com.google.android.gms/com.google.android.gms.semanticlocation.service.SemanticLocationService"
#ui_print "✦ Disabled location services."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to components within Google Play Services related to Google Play Games.
su -c "pm disable com.google.android.gms/com.google.android.gms.games.chimera.GamesSignInIntentServiceProxy"
su -c "pm disable com.google.android.gms/com.google.android.gms.games.chimera.GamesSyncServiceNotificationProxy"
su -c "pm disable com.google.android.gms/com.google.android.gms.games.chimera.GamesUploadServiceProxy"
su -c "pm disable com.google.android.gms/com.google.android.gms.gp.gameservice.GameService"
su -c "pm disable com.google.android.gms/com.google.android.gms.gp.gameservice.GameSessionService"
#ui_print "✦ Disabled Google Play Games-related services."
#ui_print " "
#sleep 1.5

# This code aims to disable services related to Google Instant Apps.
su -c "pm disable com.google.android.gms/com.google.android.gms.chimera.GmsApiServiceNoInstantApps"
su -c "pm disable com.google.android.gms/com.google.android.gms.chimera.PersistentApiServiceNoInstantApps"
su -c "pm disable com.google.android.gms/com.google.android.gms.instantapps.service.InstantAppsService"
su -c "pm disable com.google.android.gms/com.google.android.gms.chimera.UiApiServiceNoInstantApps"
#ui_print "✦ Disabled Google Instant Apps services."
#ui_print " "
sleep 1.5

#Fix Integrity
pm enable com.google.android.gms/com.google.android.gms.droidguard.DroidGuardService
#ui_print "✦ Fixing CTS"
#ui_print " "
sleep 1.5

# Remove modules that conflicts with power saver
rm -rf /data/adb/modules/AdvanceCleaner
rm -rf /data/adb/modules/Energy_Saver
sleep 1

ui_print " "
# System Prop Results
echo "-------------------------------------"
ui_print " DISABLING LOGS "
echo "-------------------------------------"
ui_print " "
sleep 1
ui_print "✦ Disabled Real-Time Transport Protocol (RTP) logging"
sleep 0.5
ui_print "✦ Disabled JNI (Java Native Interface) checks, reducing logging related to native code interaction."
sleep 0.5
ui_print "✦ Stopped logging slow database queries."
sleep 0.5
ui_print "✦ Disabled debugging logs related to Qualcomm's Sensor Network Services (SNS)."
sleep 0.5
ui_print "✦ Disabled profiling logs for the EGL graphics API."
sleep 0.5
ui_print "✦ Disabled logging related to gamed and Wayland."
sleep 0.5
ui_print "✦ Disabled logging related to the Hardware Composer (HWC) and SurfaceFlinger components."
sleep 0.5
ui_print "✦ Disabled logging related to SurfaceFlinger's backpressure mechanism."
sleep 0.5
ui_print "✦ Disabled logging related to surface re-computations."
sleep 0.5
ui_print "✦ Disabled logging of Application Not Responding (ANR) events."
sleep 0.5
ui_print "✦ Disabled GPU-based pixel buffers, impacting rendering."
sleep 0.5
ui_print "✦ Disabled real-time logcat output and streaming."
sleep 0.5
ui_print "✦ Disabled TCP metrics logging."
sleep 0.5
ui_print "✦ Disabled logging related to the Stagefright media framework."
sleep 0.5
ui_print "✦ Disabled various profiling tools."
sleep 0.5
ui_print "✦ Disabled StrictMode, which checks for potential performance and security issues."
sleep 0.5
ui_print "✦ Changed behavior related to EGL context destruction."
sleep 0.5
ui_print "✦ Disabled support for Kernel Samepage Merging (KSM), a memory optimization technique."
sleep 0.5
ui_print "✦ Disabled \"checkin\" logging that sends system information to Google."
sleep 0.5
ui_print "✦ Disabled debugging capabilities for the device."
sleep 0.5
ui_print "✦ Setting the log buffer size to zero, effectively disable the log system."
sleep 0.5
ui_print "✦ Disabled the default compression cache."
sleep 0.5
ui_print "✦ Disabled JNI checks and QEMU-related logging."
sleep 0.5
ui_print "✦ Disabled battery-related logging."
sleep 0.5
ui_print "✦ Disabled multiple simultaneous call ringtones."
sleep 0.5
ui_print "✦ Disabled the RW logger, used for debugging network interactions."
sleep 0.5
ui_print "✦ Disabled IMS (IP Multimedia Subsystem) debug logs."
sleep 0.5
ui_print "✦ Disabled debugging related to Wi-Fi Direct (WFD)."
sleep 0.5
ui_print "✦ Disabled AAC support for Bluetooth A2DP."
sleep 0.5
ui_print "✦ Disabled QMI (Qualcomm MSM Interface) logging for ADB."
sleep 0.5
ui_print "✦ Disabled debug logging for the sensors HAL (Hardware Abstraction Layer)."
sleep 0.5
ui_print "✦ Disabled logging and crash reports related to Broadcom components."
sleep 0.5
ui_print "✦ Disabled an override for USB tethering."
sleep 0.5
ui_print "✦ Disabled an OEM socket for the radio."
sleep 0.5
ui_print "✦ Disabled virtual WFD capabilities."
sleep 0.5
ui_print "✦ Disabled various IMS logging and functionality."
sleep 0.5
ui_print "✦ Enabled offline logging for the kernel and logcat."
sleep 0.5
ui_print "✦ Disabled OEM-specific dumps"
sleep 0.5
ui_print "✦ Enabled the system's sleep mode."
sleep 0.5
ui_print "✦ Force disabled error reports and ulog."
sleep 0.5
ui_print "✦ Disabled debugging related to display management."
sleep 0.5
ui_print "✦ Enabled profiling for game tools."
sleep 0.5
ui_print "✦ Disabled GPU performance mode."
sleep 0.5
ui_print "✦ Disabled concurrent A2DP connections for FM radio."
sleep 0.5
ui_print "✦ Disabled B-frame encoding for the video decoder."
sleep 0.5
ui_print "✦ Disabled video decoder debugging."
sleep 0.5
ui_print "✦ Disabled Ultra Buffer With Cache (UBWC) for video."
sleep 0.5
ui_print "✦ Setting the Wi-Fi interface to \wlan0\ "
sleep 0.5
ui_print "✦ Setting the systems composition type to GPU-based."
sleep 0.5
ui_print "✦ Disabled various SurfaceFlinger display options."
sleep 0.5
ui_print "✦ Disabled specific tags for the \"atrace\" profiling tool."
sleep 0.5
ui_print "✦ Disabled a mechanism for killing tasks that are allocating memory excessively."
sleep 0.5
ui_print "✦ Disabled logging for specific services."
sleep 0.5
ui_print "✦ Disabled redirecting standard input/output to the log system."
sleep 0.5
ui_print "✦ Disabled additional profiling features."
sleep 0.5
ui_print "✦ Disabled StrictMode, which checks for potential performance and security issues."
sleep 0.5
ui_print "✦ Disabled bytecode verification for the Dalvik VM, impacting security."
sleep 0.5
ui_print "✦ Disabled debug logging for memory allocation."
sleep 0.5
ui_print "✦ Disabled persistent caching for the A/V system."
sleep 0.5
ui_print "✦ Disabled RAM dumps for the SSR (System Server Recovery) service."
sleep 0.5
ui_print "✦ Disabled various log outputs related to the systems core functionality, including media playback, rendering, and audio output."
sleep 0.5
ui_print "✦ Disabled debug-specific logging and testing"
sleep 0.5

# Cooking Logs & Cache 
ui_print "-------------------------------------"
ui_print "✦ Deleting Cache Resources"
rm -rf /data/resource-cache
sleep 0.5
 
ui_print "✦ Deleting Package Cache"
rm -rf /data/package_cache
sleep 0.5
 
ui_print "✦ Deleting Dalvik Cache"
rm -rf /data/dalvik-cache
sleep 0.5
 
ui_print "✦ Deleting Cached Data"
rm -rf /data/cache
sleep 0.5
    
ui_print "✦ Deleting WLAN Logs"
rm -rf /data/vendor/wlan_logs
sleep 0.5
    
ui_print "✦ Deleting System Logs"
rm -rf /dev/log/*
sleep 0.5
    
ui_print "✦ Deleting Kernel Logs"
rm -rf /sys/kernel/debug/*
sleep 0.5
     
ui_print "✦ Deleting System Package Cache"
rm -rf /data/system/package_cache
sleep 0.5
     
ui_print "✦ Deleting Thumbnail Cache"
rm -rf /data/media/0/DCIM/.thumbnails
rm -rf /data/media/0/Pictures/.thumbnails
rm -rf /data/media/0/Music/.thumbnails
rm -rf /data/media/0/Movies/.thumbnails
sleep 0.5
    
ui_print "✦ Deleting Thermal Logs"
rm -rf /data/vendor/thermal/thermal.dump
rm -rf /data/vendor/thermal/last_thermal.dump
rm -rf /data/vendor/thermal/thermal_history.dump
rm -rf /data/vendor/thermal/thermal_history_last.dump
sleep 0.5
     
ui_print "✦ Deleting ANR Logs"
rm -rf /data/anr/*
sleep 0.5
     
ui_print "✦ Deleting Dev Logs"
rm -rf /dev/log/*
sleep 0.5
  
ui_print "✦ Disabled Timer Migration"
echo "0" > /proc/sys/kernel/timer_migration
sleep 0.5
        
ui_print "✦ Disabled SeLinux Logs"
echo 0 >/sys/fs/selinux/log/deny_unknown
sleep 0.5
  
ui_print "✦ Disabled logs in init.rc..."
sed -i 's/service logd/service logd disabled/g' /system/etc/init/rc
sed -i 's/on property:sys.log.redirect-stdio=1/on property:sys.log.redirect-stdio=0/g' /system/etc/init/rc
sed -i 's/setprop persist.service.logging.enable 1/# setprop persist.service.logging.enable 1/g' /system/etc/init/rc
sleep 0.5
    
ui_print "-------------------------------------"
ui_print "✦ Disabled Kernel Logs" 
sysctl -w kernel.panic=0
sysctl -w vm.panic_on_oom=0
sysctl -w kernel.panic_on_oops=0
sysctl -w kernel.softlockup_panic=0
sysctl -w vm.oom_dump_tasks=0
sysctl -w vm.oom_kill_allocating_task=0
echo "0 0 0 0" > /proc/sys/kernel/printk
echo "off" > /proc/sys/kernel/printk_devkmsg
echo "0" > /proc/sys/debug/exception-trace
echo "0" > /proc/sys/kernel/compat-log
sleep 0.5

ui_print "-------------------------------------"
ui_print "✦ Optimizing storage performance"
fstrim -v /cache
fstrim -v /system
fstrim -v /vendor
fstrim -v /data
fstrim -v /preload
sleep 0.5
    
ui_print " "
ui_print " "
ui_print "   ╱▔▔▔▔▔╲⠀REMEMBER"
ui_print "⠀╱⠀⠀╱▔╲╲╲▏⠀⠀   ⠀HUMAN"
ui_print "╱⠀⠀╱━╱▔▔▔▔▔╲━╮⠀⠀"
ui_print "▏⠀▕┃▕╱▔╲╱▔╲▕╮┃⠀⠀"
ui_print "▏⠀▕╰━▏▊▕▕▋▕▕━╯⠀⠀"
ui_print "╲⠀⠀╲╱▔╭╮▔▔┳╲╲⠀⠀⠀"
ui_print "⠀╲⠀⠀▏╭━━━━╯▕▕⠀⠀⠀"
ui_print "⠀⠀╲⠀╲▂▂▂▂▂▂╱╱⠀⠀⠀"
ui_print "⠀⠀⠀⠀▏⠀⠀⠀⠀⠀⠀⠀⠀⠀╲⠀"
ui_print "⠀⠀⠀⠀▏⠀⠀⠀⠀⠀⠀▕╲⠀⠀╲"
ui_print "⠀╱▔╲▏⠀⠀⠀⠀⠀⠀▕╱▔╲▕"
ui_print "⠀▏ ⠀⠀⠀╰⠀⠀⠀⠀╯⠀⠀⠀▕▕"
ui_print "⠀╲⠀⠀⠀╲⠀⠀⠀⠀╱⠀⠀⠀╱⠀╲"
ui_print "⠀⠀╲⠀⠀▕▔▔▔▔▏⠀⠀╱╲╲╲▏"
ui_print "⠀╱▔⠀⠀▕⠀⠀⠀⠀▏⠀⠀▔╲▔▔"
ui_print "⠀╲▂▂▂╱⠀⠀⠀⠀╲▂▂▂╱⠀"
ui_print " " 
ui_print "-----------------------------------------------" 
ui_print "-     EXTRACT THE MODULE      " 
ui_print "-     READ THE readme file       "
ui_print "-     TO PERMANENTLY REMOVE THIS MODULE  " 
ui_print "-----------------------------------------------" 
ui_print "🙈" 
ui_print " Completing installation in"
sleep 1
ui_print " 5s "
sleep 1
ui_print " 4s "
sleep 1
ui_print " 3s "
sleep 1
ui_print " 2s "
sleep 1
ui_print " 1s "
sleep 1
}

on_install() {
# The following is the default implementation: extract $ZIPFILE/system to $MODPATH
  unzip -o "$ZIPFILE" 'system/*' -d $MODPATH >&2
}
# Permission
  set_permissions() {
  set_perm_recursive $MODPATH 0 0 0755 0644
  
# Redirect Module Release Source
  nohup am start -a android.intent.action.VIEW -d https://t.me/MeowRedirect/3 >/dev/null 2>&1 &
}

# end of file